﻿Imports Infragistics.Controls.Charts
Imports System.Linq

Class MainWindow

    Private Sub diagram_MouseMove(sender As Object, e As MouseEventArgs)
        Dim mousePos As Point = e.GetPosition(diagram)
        Canvas.SetLeft(RectBounds, mousePos.X)
        Canvas.SetTop(RectBounds, mousePos.Y)

        Dim connections As IEnumerable(Of DiagramConnection) = diagram.FindDiagramItemsInRect(Of DiagramConnection) (New Windows.Rect(mousePos.X, mousePos.Y, 100, 100))
        intersectedList.ItemsSource = From c In connections
                                      Select (c.ToString())
    End Sub

    Private Sub Window_Loaded(sender As Object, e As RoutedEventArgs)
        Dim node1 As DiagramNode = New DiagramNode()
        node1.Key = "node1"
        node1.Content = "Some text that is long enough to cause it to wrap"
        node1.Height = 100
        node1.Width = 150
        node1.Position = New Point(200, 20)
        node1.HorizontalContentAlignment = System.Windows.HorizontalAlignment.Left
        node1.DisplayTemplate = Me.LayoutRoot.Resources("DiagramNodeDisplayTemplate")

        Dim node2 As DiagramNode = New DiagramNode()
        node2.Key = "node2"
        node2.Content = "Condition"
        node2.Height = 100
        node2.Width = 150
        node2.ShapeType = DiagramShapeType.Rhombus
        node2.Position = New Point(200, 200)

        Dim node3 As DiagramNode = New DiagramNode()
        node3.Key = "node3"
        node3.Content = "End"
        node3.Height = 100
        node3.Width = 150
        node3.ShapeType = DiagramShapeType.Ellipse
        node3.Position = New Point(200, 380)

        Dim conn1 As DiagramConnection = New DiagramConnection()
        conn1.StartNodeKey = "node1"
        conn1.EndNodeKey = "node2"
        conn1.ConnectionType = DiagramConnectionType.Straight
        conn1.Fill = Brushes.Red
        conn1.Stroke = Brushes.Red

        Dim conn2 As DiagramConnection = New DiagramConnection()
        conn2.StartNodeKey = "node2"
        conn2.EndNodeKey = "node3"
        conn2.ConnectionType = DiagramConnectionType.Straight
        conn2.Content = "Yes"

        Dim conn3 As DiagramConnection = New DiagramConnection()
        conn3.StartNodeKey = "node2"
        conn3.EndNodeKey = "node1"
        conn3.StartNodeConnectionPointName = "Right"
        conn3.EndNodeConnectionPointName = "Top"
        conn3.Content = "No"

        diagram.Items.Add(node1)
        diagram.Items.Add(node2)
        diagram.Items.Add(node3)

        diagram.Items.Add(conn1)
        diagram.Items.Add(conn2)
        diagram.Items.Add(conn3)
    End Sub
End Class
